class Fifo
{
 private:
  char *q;
  int size;
  int in;
  int out;
  int count;
  bool statusFlag;

 public:
  // Constructor:  allocates and initializes the buffer
  Fifo(int q_size, char *fifoName);

  bool write(char data);
  char read(void);
  bool avail(void);
  int get_size(void);
  int get_count(void);
  void reset(void);
  void backspace(void);
  bool getStatusFlag(void);
  void clearStatusFlag(void);
};
